Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::SegmentReader Class Reference

`#include <SegmentReader.h>`

Inheritance diagram for Lucene::SegmentReader:

## Public Member Functions

| SegmentReader ()
virtual | ~SegmentReader ()
virtual String | getClassName ()
boost::shared_ptr< SegmentReader > | shared_from_this ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
void | openDocStores ()
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Efficiently clones the IndexReader (sharing most internal state).
virtual LuceneObjectPtr | clone (bool openReadOnly, const LuceneObjectPtr &other=LuceneObjectPtr())
| Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writable reader.
SegmentReaderPtr | reopenSegment (const SegmentInfoPtr &si, bool doClone, bool openReadOnly)
virtual bool | hasDeletions ()
| Returns true if any documents have been deleted.
HashSet< String > | files ()
virtual TermEnumPtr | terms ()
| Returns an enumeration of all the terms in the index.
virtual TermEnumPtr | terms (const TermPtr &t)
| Returns an enumeration of all terms starting at a given term.
virtual DocumentPtr | document (int32_t n, const FieldSelectorPtr &fieldSelector)
| Get the `Document` at the n'th position.
virtual bool | isDeleted (int32_t n)
| Returns true if document n has been deleted.
virtual TermDocsPtr | termDocs (const TermPtr &term)
| Returns an enumeration of all the documents which contain term.
virtual TermDocsPtr | termDocs ()
| Returns an unpositioned `TermDocs` enumerator.
virtual TermPositionsPtr | termPositions ()
| Returns an unpositioned `TermPositions` enumerator.
virtual int32_t | docFreq (const TermPtr &t)
| Returns the number of documents containing the term t.
virtual int32_t | numDocs ()
| Returns the number of documents in this index.
virtual int32_t | maxDoc ()
| Returns one greater than the largest possible document number.
virtual HashSet< String > | getFieldNames (FieldOption fieldOption)
| Get a list of unique field names that exist in this index and have the specified field option information.
virtual bool | hasNorms (const String &field)
| Returns true if there are norms stored for this field.
virtual ByteArray | norms (const String &field)
| Returns the byte-encoded normalization factor for the named field of every document.
virtual void | norms (const String &field, ByteArray norms, int32_t offset)
| Read norms into a pre-allocated array.
bool | termsIndexLoaded ()
void | loadTermsIndex (int32_t termsIndexDivisor)
| NOTE: only called from IndexWriter when a near real-time reader is opened, or applyDeletes is run, sharing a segment that's still being merged. This method is not thread safe, and relies on the synchronization in IndexWriter.
bool | normsClosed ()
bool | normsClosed (const String &field)
virtual TermFreqVectorPtr | getTermFreqVector (int32_t docNumber, const String &field)
| Return a term frequency vector for the specified document and field. The vector returned contains term numbers and frequencies for all terms in the specified field of this document, if the field had storeTermVector flag set. If the flag was not set, the method returns null.
virtual void | getTermFreqVector (int32_t docNumber, const String &field, const TermVectorMapperPtr &mapper)
| Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
virtual void | getTermFreqVector (int32_t docNumber, const TermVectorMapperPtr &mapper)
| Map all the term vectors for all fields in a Document.
virtual Collection< TermFreqVectorPtr > | getTermFreqVectors (int32_t docNumber)
| Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector vector contains term numbers and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null.
String | getSegmentName ()
| Return the name of the segment this reader is reading.
SegmentInfoPtr | getSegmentInfo ()
| Return the SegmentInfo of the segment this reader is reading.
void | setSegmentInfo (const SegmentInfoPtr &info)
void | startCommit ()
void | rollbackCommit ()
virtual DirectoryPtr | directory ()
| Returns the directory this index resides in.
virtual LuceneObjectPtr | getFieldCacheKey ()
| This is necessary so that cloned SegmentReaders (which share the underlying postings data) will map to the same entry in the FieldCache.
virtual LuceneObjectPtr | getDeletesCacheKey ()
| This returns null if the reader has no deletions.
virtual int64_t | getUniqueTermCount ()
| Returns the number of unique terms (across all fields) in this reader.
virtual int32_t | getTermInfosIndexDivisor ()
| For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened.
virtual DocumentPtr | document (int32_t n)
| Returns the stored fields of the n'th Document in this index.
virtual TermPositionsPtr | termPositions (const TermPtr &term)

Returns an enumeration of all the documents which contain term. For each document, in addition to the document number and frequency of the term in that document, a list of all of the ordinal positions of the term in the document is available. Thus, this method positions of the term in the document is available. This positional information facilitates phrase and proximity searching. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

Public Member Functions inherited from Lucene::IndexReader
| IndexReader ()
virtual | ~IndexReader ()
boost::shared_ptr< IndexReader > | shared_from_this ()
int32_t | getRefCount ()
| Returns the current refCount for this reader.
void | incRef ()

Increments the refCount of this IndexReader instance. RefCounts are used to determine when a reader can be closed safely, i.e. as soon as there are no more references. Be sure to always call a corresponding `decRef`, in a finally clause; otherwise the reader may never be closed. Note that `close` simply calls decRef(), which means that the IndexReader will not really be closed until `decRef` has been called for all outstanding references.

void | decRef ()
| Decreases the refCount of this IndexReader instance. If the refCount drops to 0, then pending changes (if any) are committed to the index and this reader is closed.
virtual IndexReaderPtr | reopen ()
| Refreshes an IndexReader if the index has changed since this instance was (re)opened.
virtual IndexReaderPtr | reopen (bool openReadOnly)
| Just like `reopen()`, except you can change the readOnly of the original reader. If the index is unchanged but readOnly is different then a new reader will be returned.
virtual IndexReaderPtr | reopen (const IndexCommitPtr &commit)
| Reopen this reader on a specific commit point. This always returns a readOnly reader. If the specified commit point matches what this reader is already on, and this reader is already readOnly, then this same instance is returned; if it is not already readOnly, a readOnly clone is returned.
virtual int64_t | getVersion ()
| Version number when this IndexReader was opened. Not implemented in the IndexReader base class.
virtual MapStringString | getCommitUserData ()
| Retrieve the String userData optionally passed to IndexWriter::commit. This will return null if `IndexWriter#commit(MapStringString)` has never been called for this index.
virtual bool | isCurrent ()
| Check whether any new changes have occurred to the index since this reader was opened.
virtual bool | isOptimized ()
| Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class.
int32_t | numDeletedDocs ()
| Returns the number of deleted documents.
virtual bool | hasChanges ()
| Used for testing.
virtual void | setNorm (int32_t doc, const String &field, uint8_t value)
| Resets the normalization factor for the named field of the named document. The norm represents the product of the field's `boost` and its `length normalization`. Thus, to preserve the length normalization values when resetting this, one should base the new value upon the old.
virtual void | setNorm (int32_t doc, const String &field, double value)
| Resets the normalization factor for the named field of the named document.
virtual void | deleteDocument (int32_t docNum)
| Deletes the document numbered docNum. Once a document is deleted it will not appear in TermDocs or TermPostitions enumerations. Attempts to read its field with the `document` method will result in an error. The presence of this document may still be reflected in the `docFreq` statistic, though this will be corrected eventually as the index is further modified.
virtual int32_t | deleteDocuments (const TermPtr &term)
| Deletes all documents that have a given term indexed. This is useful if one uses a document field to hold a unique ID string for the document. Then to delete such a document, one merely constructs a term with the appropriate field and the unique ID string as its text and passes it to this method. See `deleteDocument(int)` for information about when this deletion will become effective.
virtual void | undeleteAll ()
| Undeletes all documents currently marked as deleted in this index.
void | flush ()
void | flush (MapStringString commitUserData)
void | commit (MapStringString commitUserData)
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics).
void | close ()
| Closes files associated with this index. Also saves any new deletions to disk. No other methods should be called after this has been called.
virtual IndexCommitPtr | getIndexCommit ()
| Return the IndexCommit that this reader has opened. This method is only implemented by those readers that correspond to a Directory with its own segments_N file.
virtual Collection< IndexReaderPtr > | getSequentialSubReaders ()
| Returns the sequential sub readers that this reader is logically composed of. For example, IndexSearcher uses this API to drive searching by one sub reader at a time. If this reader is not composed of sequential child readers, it should return null. If this method returns an empty array, that means this reader is a null reader (for example a MultiReader that has no sub readers).
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual int32_t | hashCode ()
| Return hash code for this object.
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
virtual String | toString ()
| Returns a string representation of the object.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()
static SegmentReaderPtr | get (bool readOnly, const SegmentInfoPtr &si, int32_t termInfosIndexDivisor)
static SegmentReaderPtr | get (bool readOnly, const DirectoryPtr &dir, const SegmentInfoPtr &si, int32_t readBufferSize, bool doOpenStores, int32_t termInfosIndexDivisor)
static bool | hasDeletions (const SegmentInfoPtr &si)
static bool | usesCompoundFile (const SegmentInfoPtr &si)
static bool | hasSeparateNorms (const SegmentInfoPtr &si)
static SegmentReaderPtr | getOnlySegmentReader (const DirectoryPtr &dir)
static SegmentReaderPtr | getOnlySegmentReader (const IndexReaderPtr &reader)
Static Public Member Functions inherited from Lucene::IndexReader
static String | _getClassName ()
static IndexReaderPtr | open (const DirectoryPtr &directory)
| Returns a IndexReader reading the index in the given Directory, with readOnly = true.
static IndexReaderPtr | open (const DirectoryPtr &directory, bool readOnly)
| Returns an IndexReader reading the index in the given Directory. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.
static IndexReaderPtr | open (const IndexCommitPtr &commit, bool readOnly)
| Returns an IndexReader reading the index in the given `IndexCommit`. You should pass readOnly = true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, with a custom `IndexDeletionPolicy`. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, with a custom `IndexDeletionPolicy`. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.
static IndexReaderPtr | open (const IndexCommitPtr &commit, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom `IndexDeletionPolicy`. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.
static IndexReaderPtr | open (const IndexCommitPtr &commit, const IndexDeletionPolicyPtr &deletionPolicy, bool readOnly, int32_t termInfosIndexDivisor)
| Returns an IndexReader reading the index in the given Directory, using a specific commit and with a custom `IndexDeletionPolicy`. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the reader.
static int64_t | lastModified (const DirectoryPtr &directory2)
| Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use `isCurrent()` instead.
static int64_t | getCurrentVersion (const DirectoryPtr &directory)
| Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index.
static MapStringString | getCommitUserData (const DirectoryPtr &directory)
| Reads commitUserData, previously passed to `IndexWriter#commit(MapStringString)`, from current index segments file. This will return null if `IndexWriter#commit(MapStringString)` has never been called for this index.
static bool | indexExists (const DirectoryPtr &directory)
| Returns true if an index exists at the specified directory. If the directory does not exist or if there is no index in it.
static void | main (Collection< String > args)
| Prints the filename and size of each file within a given compound file. Add the -extract flag to extract files to the current working directory. In order to make the extracted version of the index work, you have to copy the segments file from the compound index into the directory where the extracted files are stored.
static Collection< IndexCommitPtr > | listCommits (const DirectoryPtr &dir)

Returns all commit points that exist in the Directory. Normally, because the default is `KeepOnlyLastCommitDeletionPolicy`, there would be only one commit point. But if you're using a custom `IndexDeletionPolicy` then there could be many commits. Once you have a given commit, you can open a reader on it by calling `IndexReader#open(IndexCommit,bool)`. There must be at least one commit in the Directory, else this method throws an exception. Note that if a commit is in progress while this method is running, that commit may or may not be returned array.

## Protected Member Functions

FieldInfosPtr | fieldInfos ()
TermVectorsReaderPtr | getTermVectorsReader ()
| Create a clone from the initial TermVectorsReader and store it in the ThreadLocal.
TermVectorsReaderPtr | getTermVectorsReaderOrig ()
FieldsReaderPtr | getFieldsReader ()
bool | checkDeletedCounts ()
void | loadDeletedDocs ()
virtual ByteArray | cloneNormBytes (ByteArray bytes)
| Clones the norm bytes. May be overridden by subclasses.
virtual BitVectorPtr | cloneDeletedDocs (const BitVectorPtr &bv)
| Clones the deleteDocs BitVector. May be overridden by subclasses.
virtual void | doCommit (MapStringString commitUserData)
| Implements commit.
virtual void | commitChanges (MapStringString commitUserData)
virtual void | doClose ()
| Implements close.
virtual void | doDelete (int32_t docNum)
| Implements deletion of the document numbered docNum. Applications should call `deleteDocument(int)` or `deleteDocuments(Term)`.
virtual void | doUndeleteAll ()
| Implements actual undeleteAll() in subclass.
ByteArray | getNorms (const String &field)
| can return null if norms aren't stored
virtual void | doSetNorm (int32_t doc, const String &field, uint8_t value)
| Implements setNorm in subclass.
void | openNorms (const DirectoryPtr &cfsDir, int32_t readBufferSize)
Protected Member Functions inherited from Lucene::IndexReader
void | ensureOpen ()
virtual void | acquireWriteLock ()
| Does nothing by default. Subclasses that require a write lock for index modifications must implement this method.
void | commit ()
| Commit changes resulting from delete, undeleteAll, or setNorm operations. If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics).
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

bool | readOnly
INTERNAL | : BitVectorPtr deletedDocs
SegmentReaderRefPtr | deletedDocsRef
CoreReadersPtr | core
FieldsReaderLocalPtr | fieldsReaderLocal
SegmentInfoPtr | rollbackSegmentInfo
CloseableThreadLocal< TermVectorsReader > | termVectorsLocal
MapStringNorm | _norms
Protected Attributes inherited from Lucene::IndexReader
bool | closed
bool | _hasChanges
int32_t | refCount
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Public Types inherited from Lucene::IndexReader
enum | FieldOption { FIELD_OPTION_ALL , FIELD_OPTION_INDEXED , FIELD_OPTION_STORES_PAYLOADS , FIELD_OPTION_OMIT_TERM_FREQ_AND_POSITIONS , FIELD_OPTION_UNINDEXED , FIELD_OPTION_INDEXED_WITH_TERMVECTOR , FIELD_OPTION_INDEXED_NO_TERMVECTOR , FIELD_OPTION_TERMVECTOR , FIELD_OPTION_TERMVECTOR_WITH_POSITION , FIELD_OPTION_TERMVECTOR_WITH_OFFSET , FIELD_OPTION_TERMVECTOR_WITH_POSITION_OFFSET }
| Constants describing field properties, for example used for `IndexReader#getFieldNames(FieldOption)`. More...
Static Public Attributes inherited from Lucene::IndexReader
static const int32_t | DEFAULT_TERMS_INDEX_DIVISOR
Static Protected Member Functions inherited from Lucene::IndexReader
static IndexReaderPtr | open (const DirectoryPtr &directory, const IndexDeletionPolicyPtr &deletionPolicy, const IndexCommitPtr &commit, bool readOnly, int32_t termInfosIndexDivisor)

## Constructor & Destructor Documentation

## ◆ SegmentReader()

Lucene::SegmentReader::SegmentReader | ( |  | ) |

Referenced by _getClassName().

## ◆ ~SegmentReader()

virtual Lucene::SegmentReader::~SegmentReader | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

String Lucene::SegmentReader::_getClassName | ( |  | ) |

inline static

References SegmentReader().

## ◆ checkDeletedCounts()

bool Lucene::SegmentReader::checkDeletedCounts | ( |  | ) |

protected

## ◆ clone() [1/2]

virtual LuceneObjectPtr Lucene::SegmentReader::clone | ( | bool | openReadOnly,
|  | const LuceneObjectPtr & | other = LuceneObjectPtr() )

virtual

Clones the IndexReader and optionally changes readOnly. A readOnly reader cannot open a writable reader.

Reimplemented from Lucene::IndexReader.

## ◆ clone() [2/2]

virtual LuceneObjectPtr Lucene::SegmentReader::clone | ( | const LuceneObjectPtr & | other = LuceneObjectPtr() | ) |

virtual

Efficiently clones the IndexReader (sharing most internal state).

On cloning a reader with pending changes (deletions, norms), the original reader transfers its write lock to the cloned reader. This means only the cloned reader may make further changes to the index, and commit the changes to the index on close, but the old reader still reflects all changes made up until it was cloned.

Like `reopen()`, it's safe to make changes to either the original or the cloned reader: all shared mutable state obeys "copy on write" semantics to ensure the changes are not seen by other readers.

Reimplemented from Lucene::IndexReader.

## ◆ cloneDeletedDocs()

virtual BitVectorPtr Lucene::SegmentReader::cloneDeletedDocs | ( | const BitVectorPtr & | bv | ) |

protected virtual

Clones the deleteDocs BitVector. May be overridden by subclasses.

Parameters

  bv | BitVector to clone

Returns
  New BitVector

## ◆ cloneNormBytes()

virtual ByteArray Lucene::SegmentReader::cloneNormBytes | ( | ByteArray | bytes | ) |

protected virtual

Clones the norm bytes. May be overridden by subclasses.

Parameters

  bytes | Byte array to clone

Returns
  New BitVector

## ◆ commitChanges()

virtual void Lucene::SegmentReader::commitChanges | ( | MapStringString | commitUserData | ) |

protected virtual

## ◆ directory()

virtual DirectoryPtr Lucene::SegmentReader::directory | ( |  | ) |

virtual

Returns the directory this index resides in.

Reimplemented from Lucene::IndexReader.

## ◆ docFreq()

virtual int32_t Lucene::SegmentReader::docFreq | ( | const TermPtr & | t | ) |

virtual

Returns the number of documents containing the term t.

Implements Lucene::IndexReader.

## ◆ doClose()

virtual void Lucene::SegmentReader::doClose | ( |  | ) |

protected virtual

Implements close.

Implements Lucene::IndexReader.

## ◆ doCommit()

virtual void Lucene::SegmentReader::doCommit | ( | MapStringString | commitUserData | ) |

protected virtual

Implements commit.

Implements Lucene::IndexReader.

## ◆ document() [1/2]

virtual DocumentPtr Lucene::IndexReader::document | ( | int32_t | n | ) |

virtual

Returns the stored fields of the n'th Document in this index.

NOTE: for performance reasons, this method does not check if the requested document is deleted, and therefore asking for a deleted document may yield unspecified results. Usually this is not required, however you can call `isDeleted(int)` with the requested document ID to verify the document is not deleted.

Reimplemented from Lucene::IndexReader.

## ◆ document() [2/2]

virtual DocumentPtr Lucene::SegmentReader::document | ( | int32_t | n,
|  | const FieldSelectorPtr & | fieldSelector )

virtual

Get the `Document` at the n'th position.

Implements Lucene::IndexReader.

## ◆ doDelete()

virtual void Lucene::SegmentReader::doDelete | ( | int32_t | docNum | ) |

protected virtual

Implements deletion of the document numbered docNum. Applications should call `deleteDocument(int)` or `deleteDocuments(Term)`.

Implements Lucene::IndexReader.

## ◆ doSetNorm()

virtual void Lucene::SegmentReader::doSetNorm | ( | int32_t | doc,
|  | const String & | field,
|  | uint8_t | value )

protected virtual

Implements setNorm in subclass.

Implements Lucene::IndexReader.

## ◆ doUndeleteAll()

virtual void Lucene::SegmentReader::doUndeleteAll | ( |  | ) |

protected virtual

Implements actual undeleteAll() in subclass.

Implements Lucene::IndexReader.

## ◆ fieldInfos()

FieldInfosPtr Lucene::SegmentReader::fieldInfos | ( |  | ) |

protected

## ◆ files()

HashSet< String > Lucene::SegmentReader::files | ( |  | ) |

## ◆ get() [1/2]

SegmentReaderPtr Lucene::SegmentReader::get | ( | bool | readOnly,
|  | const DirectoryPtr & | dir,
|  | const SegmentInfoPtr & | si,
|  | int32_t | readBufferSize,
|  | bool | doOpenStores,
|  | int32_t | termInfosIndexDivisor )

static

References readOnly.

## ◆ get() [2/2]

SegmentReaderPtr Lucene::SegmentReader::get | ( | bool | readOnly,
|  | const SegmentInfoPtr & | si,
|  | int32_t | termInfosIndexDivisor )

static

References readOnly.

## ◆ getClassName()

virtual String Lucene::SegmentReader::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::IndexReader.

Reimplemented in Lucene::ReadOnlySegmentReader.

## ◆ getDeletesCacheKey()

virtual LuceneObjectPtr Lucene::SegmentReader::getDeletesCacheKey | ( |  | ) |

virtual

This returns null if the reader has no deletions.

Reimplemented from Lucene::IndexReader.

## ◆ getFieldCacheKey()

virtual LuceneObjectPtr Lucene::SegmentReader::getFieldCacheKey | ( |  | ) |

virtual

This is necessary so that cloned SegmentReaders (which share the underlying postings data) will map to the same entry in the FieldCache.

Reimplemented from Lucene::IndexReader.

## ◆ getFieldNames()

virtual HashSet< String > Lucene::SegmentReader::getFieldNames | ( | FieldOption | fieldOption | ) |

virtual

Get a list of unique field names that exist in this index and have the specified field option information.

Implements Lucene::IndexReader.

## ◆ getFieldsReader()

FieldsReaderPtr Lucene::SegmentReader::getFieldsReader | ( |  | ) |

protected

## ◆ getNorms()

ByteArray Lucene::SegmentReader::getNorms | ( | const String & | field | ) |

protected

can return null if norms aren't stored

## ◆ getOnlySegmentReader() [1/2]

SegmentReaderPtr Lucene::SegmentReader::getOnlySegmentReader | ( | const DirectoryPtr & | dir | ) |

static

## ◆ getOnlySegmentReader() [2/2]

SegmentReaderPtr Lucene::SegmentReader::getOnlySegmentReader | ( | const IndexReaderPtr & | reader | ) |

static

## ◆ getSegmentInfo()

SegmentInfoPtr Lucene::SegmentReader::getSegmentInfo | ( |  | ) |

Return the SegmentInfo of the segment this reader is reading.

## ◆ getSegmentName()

String Lucene::SegmentReader::getSegmentName | ( |  | ) |

Return the name of the segment this reader is reading.

## ◆ getTermFreqVector() [1/3]

virtual TermFreqVectorPtr Lucene::SegmentReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const String & | field )

virtual

Return a term frequency vector for the specified document and field. The vector returned contains term numbers and frequencies for all terms in the specified field of this document, if the field had storeTermVector flag set. If the flag was not set, the method returns null.

Implements Lucene::IndexReader.

## ◆ getTermFreqVector() [2/3]

virtual void Lucene::SegmentReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const String & | field,
|  | const TermVectorMapperPtr & | mapper )

virtual

Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.

Implements Lucene::IndexReader.

## ◆ getTermFreqVector() [3/3]

virtual void Lucene::SegmentReader::getTermFreqVector | ( | int32_t | docNumber,
|  | const TermVectorMapperPtr & | mapper )

virtual

Map all the term vectors for all fields in a Document.

Implements Lucene::IndexReader.

## ◆ getTermFreqVectors()

virtual Collection< TermFreqVectorPtr > Lucene::SegmentReader::getTermFreqVectors | ( | int32_t | docNumber | ) |

virtual

Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector vector contains term numbers and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null.

Implements Lucene::IndexReader.

## ◆ getTermInfosIndexDivisor()

virtual int32_t Lucene::SegmentReader::getTermInfosIndexDivisor | ( |  | ) |

virtual

For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor as specified when the reader was opened.

Reimplemented from Lucene::IndexReader.

## ◆ getTermVectorsReader()

TermVectorsReaderPtr Lucene::SegmentReader::getTermVectorsReader | ( |  | ) |

protected

Create a clone from the initial TermVectorsReader and store it in the ThreadLocal.

Returns
  TermVectorsReader

## ◆ getTermVectorsReaderOrig()

TermVectorsReaderPtr Lucene::SegmentReader::getTermVectorsReaderOrig | ( |  | ) |

protected

## ◆ getUniqueTermCount()

virtual int64_t Lucene::SegmentReader::getUniqueTermCount | ( |  | ) |

virtual

Returns the number of unique terms (across all fields) in this reader.

Reimplemented from Lucene::IndexReader.

## ◆ hasDeletions() [1/2]

virtual bool Lucene::SegmentReader::hasDeletions | ( |  | ) |

virtual

Returns true if any documents have been deleted.

Implements Lucene::IndexReader.

## ◆ hasDeletions() [2/2]

bool Lucene::SegmentReader::hasDeletions | ( | const SegmentInfoPtr & | si | ) |

static

## ◆ hasNorms()

virtual bool Lucene::SegmentReader::hasNorms | ( | const String & | field | ) |

virtual

Returns true if there are norms stored for this field.

Reimplemented from Lucene::IndexReader.

## ◆ hasSeparateNorms()

bool Lucene::SegmentReader::hasSeparateNorms | ( | const SegmentInfoPtr & | si | ) |

static

## ◆ initialize()

virtual void Lucene::SegmentReader::initialize | ( |  | ) |

virtual

Called directly after instantiation to create objects that depend on this object being fully constructed.

Reimplemented from Lucene::LuceneObject.

References Lucene::IndexReader::document(), and Lucene::IndexReader::termPositions().

## ◆ isDeleted()

virtual bool Lucene::SegmentReader::isDeleted | ( | int32_t | n | ) |

virtual

Returns true if document n has been deleted.

Implements Lucene::IndexReader.

Reimplemented in Lucene::ReadOnlySegmentReader.

## ◆ loadDeletedDocs()

void Lucene::SegmentReader::loadDeletedDocs | ( |  | ) |

protected

## ◆ loadTermsIndex()

void Lucene::SegmentReader::loadTermsIndex | ( | int32_t | termsIndexDivisor | ) |

NOTE: only called from IndexWriter when a near real-time reader is opened, or applyDeletes is run, sharing a segment that's still being merged. This method is not thread safe, and relies on the synchronization in IndexWriter.

## ◆ maxDoc()

virtual int32_t Lucene::SegmentReader::maxDoc | ( |  | ) |

virtual

Returns one greater than the largest possible document number.

Implements Lucene::IndexReader.

## ◆ norms() [1/2]

virtual ByteArray Lucene::SegmentReader::norms | ( | const String & | field | ) |

virtual

Returns the byte-encoded normalization factor for the named field of every document.

Implements Lucene::IndexReader.

Referenced by norms().

## ◆ norms() [2/2]

virtual void Lucene::SegmentReader::norms | ( | const String & | field,
|  | ByteArray | norms,
|  | int32_t | offset )

virtual

Read norms into a pre-allocated array.

Implements Lucene::IndexReader.

References norms().

## ◆ normsClosed() [1/2]

bool Lucene::SegmentReader::normsClosed | ( |  | ) |

## ◆ normsClosed() [2/2]

bool Lucene::SegmentReader::normsClosed | ( | const String & | field | ) |

## ◆ numDocs()

virtual int32_t Lucene::SegmentReader::numDocs | ( |  | ) |

virtual

Returns the number of documents in this index.

Implements Lucene::IndexReader.

## ◆ openDocStores()

void Lucene::SegmentReader::openDocStores | ( |  | ) |

## ◆ openNorms()

void Lucene::SegmentReader::openNorms | ( | const DirectoryPtr & | cfsDir,
|  | int32_t | readBufferSize )

protected

## ◆ reopenSegment()

SegmentReaderPtr Lucene::SegmentReader::reopenSegment | ( | const SegmentInfoPtr & | si,
|  | bool | doClone,
|  | bool | openReadOnly )

## ◆ rollbackCommit()

void Lucene::SegmentReader::rollbackCommit | ( |  | ) |

## ◆ setSegmentInfo()

void Lucene::SegmentReader::setSegmentInfo | ( | const SegmentInfoPtr & | info | ) |

## ◆ shared_from_this()

boost::shared_ptr< SegmentReader > Lucene::SegmentReader::shared_from_this | ( |  | ) |

inline

## ◆ startCommit()

void Lucene::SegmentReader::startCommit | ( |  | ) |

## ◆ termDocs() [1/2]

virtual TermDocsPtr Lucene::SegmentReader::termDocs | ( |  | ) |

virtual

Returns an unpositioned `TermDocs` enumerator.

Implements Lucene::IndexReader.

## ◆ termDocs() [2/2]

virtual TermDocsPtr Lucene::SegmentReader::termDocs | ( | const TermPtr & | term | ) |

virtual

Returns an enumeration of all the documents which contain term.

Reimplemented from Lucene::IndexReader.

## ◆ termPositions() [1/2]

virtual TermPositionsPtr Lucene::SegmentReader::termPositions | ( |  | ) |

virtual

Returns an unpositioned `TermPositions` enumerator.

Implements Lucene::IndexReader.

## ◆ termPositions() [2/2]

virtual TermPositionsPtr Lucene::IndexReader::termPositions | ( | const TermPtr & | term | ) |

virtual

Returns an enumeration of all the documents which contain term. For each document, in addition to the document number and frequency of the term in that document, a list of all of the ordinal positions of the term in the document is available. Thus, this method positions of the term in the document is available. This positional information facilitates phrase and proximity searching. The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

Reimplemented from Lucene::IndexReader.

## ◆ terms() [1/2]

virtual TermEnumPtr Lucene::SegmentReader::terms | ( |  | ) |

virtual

Returns an enumeration of all the terms in the index.

Implements Lucene::IndexReader.

## ◆ terms() [2/2]

virtual TermEnumPtr Lucene::SegmentReader::terms | ( | const TermPtr & | t | ) |

virtual

Returns an enumeration of all terms starting at a given term.

Implements Lucene::IndexReader.

## ◆ termsIndexLoaded()

bool Lucene::SegmentReader::termsIndexLoaded | ( |  | ) |

## ◆ usesCompoundFile()

bool Lucene::SegmentReader::usesCompoundFile | ( | const SegmentInfoPtr & | si | ) |

static

## Field Documentation

## ◆ __pad0__

INTERNAL Lucene::SegmentReader::__pad0__

protected

## ◆ _norms

MapStringNorm Lucene::SegmentReader::_norms

protected

## ◆ core

CoreReadersPtr Lucene::SegmentReader::core

protected

## ◆ deletedDocsRef

SegmentReaderRefPtr Lucene::SegmentReader::deletedDocsRef

protected

## ◆ fieldsReaderLocal

FieldsReaderLocalPtr Lucene::SegmentReader::fieldsReaderLocal

protected

## ◆ readOnly

bool Lucene::SegmentReader::readOnly

protected

Referenced by get(), and get().

## ◆ rollbackSegmentInfo

SegmentInfoPtr Lucene::SegmentReader::rollbackSegmentInfo

protected

## ◆ termVectorsLocal

CloseableThreadLocal<TermVectorsReader> Lucene::SegmentReader::termVectorsLocal

protected

The documentation for this class was generated from the following file:

- SegmentReader.h

clucene.sourceforge.net